<?php

include('config.php');
include('database.php');
include('helpers.php');

function reportError($lineNo, $why, $ds=NULL) {
	if ($ds) {
		$ldaperrno = ldap_errno($ds);
		$ldaperrstr = ldap_err2str($ldaperrno);
	} else {
		$ldaperrno = 0;
		$ldaperrstr = "";
	}
	
   $return = array();

   $return['success'] = FALSE;
   $return['detail'] = $ldaperrstr;
   $return['why'] = $why;
   $return['line'] = $lineNo;
   $return['crap'] = $ldaperrno;

   // If the bind failed, this is an authentication failure
   if ($why == "Failed to perform bind") {
      $return['error'] = "authenticationfail";
   } else {
      $return['error'] = "internalerror";
   }

   echo json_encode($return);

	die($lineNo);
}

function checkLdap($netid, $credentials) {
	$oldErr = error_reporting(0);
	$basedn = "dc=rutgers,dc=edu";
	$server = "ldap://ldap.rutgers.edu";

	// Add more attributes here as needed.
	// SECURITY: For speed and as a security onion layer, don't specify more than is needed here.
	$requestedAttrs = array(
      "uid", 
      "rulinkRutgersEduCampusService", 
      "eduPersonPrimaryAffiliation"
   );

	$ds = ldap_connect($server) 
      or reportError(__LINE__,  "Connection failure");
	ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3)
      or reportError(__LINE__, "LDAP Version 3 required", $ds);
	ldap_start_tls($ds) 
      or reportError(__LINE__, "Failed to start encryption", $ds);

   // form an RDN: "uid=root,ou=people,dc=rutgers,dc=edu"
	$rdn = "uid=" . $netid . ",ou=people," . $basedn; 
	$bind = ldap_bind($ds, $rdn, $credentials) 
      or reportError(__LINE__, "Failed to perform bind", $ds);
	$res = ldap_search($ds, $basedn, "(uid=$netid)", $requestedAttrs) 
      or reportError(__LINE__, "Failed to perform search", $ds);
	$entries = ldap_get_entries($ds, $res) 
      or reportError(__LINE__, "Failed to retrieve entries", $ds);

	error_reporting($oldErr);
	return $entries;
}

$result = checkLdap($_POST['netid'], $_POST['password']);
$valid = array('faculty', 'staff', 'student', 'employee');
$return = array();

if (in_array($result[0]['edupersonprimaryaffiliation'][0], $valid)) {
   $return['success'] = TRUE;
   // insert into mysql   
   $netid = mysql_real_escape_string($_POST['netid']);
   $version = mysql_real_escape_string($_POST['version']);

   $query = (
      "INSERT INTO betausers " .
      "(netid, original, originalVersion, latest, latestVersion) VALUES " .
      "('$netid', NOW(), '$version', NOW(), '$version') " .
      "ON DUPLICATE KEY UPDATE latest=NOW(), latestVersion='$version';"
   );

	$oldErr = error_reporting(0);
   db_connect();
   $res = db_query($query);
	error_reporting($oldErr);
}

else {
   $return['success'] = FALSE;
   $return['error'] = "authorizationfail";
}

echo json_encode($return);

?>
